/* (C) 2004 by Dmytry Lavrov.
contact: dmytry lavrov at fastmail dot fm
 You can use it almost freely but
 1: don't [re]move that comment block from sources.
 2: if you distibute this code,or derived works in binary form,put somewhere
 information that i wrote it.
 No warranty at all,use that at your own risk.
*/
#ifdef WIN32
#include <windows.h>
#endif

#include <iostream>
#include <stdio.h>
#include <math.h>
#include <string>
#include <sstream>
#include <iomanip>

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glext.h>
#include <sdl.h>
#include <sdl_image.h>

typedef GLfloat real;

#include "../../math3/math3.h"
#include "../../math3/math3gl.h"
#include "timer.h"
#include "teapot.h"
#include "loadimg.h"
#include "utilsandhacks.h"
using namespace std;
// some glext stuff
PFNGLPOINTPARAMETERFARBPROC  glPointParameterfARB  = NULL;
PFNGLPOINTPARAMETERFVARBPROC glPointParameterfvARB = NULL;
//
void InitGL(int argc, char *argv[]);
void InitGL(){InitGL(0,0);};
void UnInitGL();

static const bool doublebuffer=true;
const real spinspeed=90*pi/180;//90 degrees per second;
const real acceleration=10;
const real deceleration=30;
const real max_game_dt=0.1;

//note - time may really need high precision.
double game_t,game_dt,computer_t;

double fpscounter_t=-100000.0;
int framescount=0;

const int screen_bits=32;
int pointtextureID=-1;

int win_width=500;
int win_height=500;
real diagonalViewAngle=90*(pi/180);
real nearClipPlane=0.1;
real farClipPlane=10000;
/*
[19.5203,       16.5588,        268.969]
quaternion:
[0.145742,      -0.683593,      -0.391515,      -0.598478]
*/

CoordSysd camera(quaterniond(0.297366,0.25144,0.208243,0.89721),vec3d(19.5203,16.5588,268.969));

void BeginSprites(){
        glEnable(GL_TEXTURE_2D);
        glBindTexture(GL_TEXTURE_2D, pointtextureID);
        glEnable( GL_BLEND );
    glBlendFunc( GL_SRC_ALPHA, GL_ONE );
        float quadratic[] =  { 0.0001f, 0.005f, 0.001f };
    glPointParameterfvARB( GL_POINT_DISTANCE_ATTENUATION_ARB, quadratic );

        float maxSize = 0.0f;
    glGetFloatv( GL_POINT_SIZE_MAX_ARB, &maxSize );
    glPointSize( maxSize );
        //std::cout<<maxSize<<std::endl;

    // The alpha of a point is calculated to allow the fading of points
    // instead of shrinking them past a defined threshold size. The threshold
    // is defined by GL_POINT_FADE_THRESHOLD_SIZE_ARB and is not clamped to
    // the minimum and maximum point sizes.

        glPointParameterfARB( GL_POINT_FADE_THRESHOLD_SIZE_ARB, 10.0f );

    glPointParameterfARB( GL_POINT_SIZE_MIN_ARB, 1.0f );
    glPointParameterfARB( GL_POINT_SIZE_MAX_ARB, /*maxSize*/100000 );
        glTexEnvf( GL_POINT_SPRITE_ARB, GL_COORD_REPLACE_ARB, GL_TRUE );
        glEnable( GL_POINT_SPRITE_ARB );
        glBegin(GL_POINTS);

};
void EndSprites(){
        glEnd();
        glDisable( GL_POINT_SPRITE_ARB );
        glDisable(GL_TEXTURE_2D);
        glDisable( GL_BLEND );
};
inline float frand(){
        return rand() / (RAND_MAX + 0.0 );
};
struct point{
vec3f p;
float r,g,b;
};

const int points_count=5000;
point points[points_count];
void InitPoints(){
        for(int i=0;i<points_count;++i){
                points[i].p.x=-5+10*frand();
                points[i].p.y=-5+10*frand();
                points[i].p.z=-5+10*frand();
                points[i].r=0.8+frand();
                points[i].g=0.8+frand();
                points[i].b=0.8+frand();
        };
};
inline void MovePoint(vec3f &p){
        static const real a=7,b=30,c=1;
        static vec3<real> d;
        d.x=a*(p.y-p.x);
        d.y=b*p.x-p.y-p.x*p.z;
        d.z=p.x*p.y-c*p.z;
        p+=d*game_dt*0.025;
};
void UpdatePoints(){

        for(int i=0;i<points_count;++i){
                MovePoint(points[i].p);
        };
};

void DrawPoints(){
        BeginSprites();
        for(int i=0;i<points_count;++i){
                glColor4f(points[i].r,points[i].g,points[i].b,1);
                glVertex3f(points[i].p.x*10,points[i].p.y*10,points[i].p.z*10);
        };

        EndSprites();

};

void DrawWorld()
{
        glColor4f(1,1,1,1);
        glutWireTeapot(10);
        DrawPoints();


};


void Display()
{
        // Clear frame buffer and depth buffer
        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
        glMatrixMode(GL_MODELVIEW);

        glmLoadTransformTo(camera);

        DrawWorld();
}

void Reshape(GLint width, GLint height)
{
        win_width=width;
        win_height=height;
        glViewport(0, 0, win_width, win_height);
        real diagonal_k=sin(diagonalViewAngle/2);
        real d=sqrt(width*width+height*height);
        real kx=(width/d)*diagonal_k*nearClipPlane;
        real ky=(height/d)*diagonal_k*nearClipPlane;
        glMatrixMode(GL_PROJECTION);
        glLoadIdentity();
        glFrustum( -kx,kx,-ky, ky, nearClipPlane, farClipPlane );
        glMatrixMode(GL_MODELVIEW);
}

SDL_Surface *screen;
Uint8 *keys;

vec3d cameravel(0,0,0);
inline decrementlen(vec3d &a,real by){
        real l=Length(a);
        if(l<by){a=vec3d(0,0,0);}else{
                l-=by;
                a=Normalized(a)*l;
        };
};
real max_computer_dt,min_computer_dt;
void UpdateTime(){
        real cur_computer_t=Time();
        real computer_dt=cur_computer_t-computer_t;
        computer_t=cur_computer_t;
        if(computer_dt<=max_game_dt){game_dt=computer_dt;}else{game_dt=max_game_dt;}
        //game_dt=0.01;
        game_t+=game_dt;

        framescount+=1;
        if(max_computer_dt<computer_dt)max_computer_dt=computer_dt;
        if(min_computer_dt>computer_dt)min_computer_dt=computer_dt;
        if((computer_t-fpscounter_t)>0.1){//update fps counter every 1/5 second
                static ostringstream os;
                os.str("");
                os<<"(C) 2004 by Dmytry Lavrov. Program info : average fps="<<setprecision(4)<<
                        ((float)framescount)/(computer_t-fpscounter_t)<<
                        "\t; maximal fps="<<(1.0/(min_computer_dt))<<
                        "\t; minimal fps="<<(1.0/(max_computer_dt))<<";";
                string s=os.str();
                SDL_WM_SetCaption(s.c_str(), s.c_str());
                fpscounter_t=computer_t;
                framescount=0;
                max_computer_dt=-1;
                min_computer_dt=100000;
        };
};
void UpdateWorld()
{



        if ( keys[SDLK_UP] ) {
                camera.Rotate(vec3d(1,0,0),-game_dt*spinspeed);
        }
        if ( keys[SDLK_DOWN] ) {
                camera.Rotate(vec3d(1,0,0),game_dt*spinspeed);
        }
        if ( keys[SDLK_LEFT] ) {
                camera.Rotate(vec3d(0,1,0),game_dt*spinspeed);
        }
        if ( keys[SDLK_RIGHT] ) {
                camera.Rotate(vec3d(0,1,0),-game_dt*spinspeed);
        };
        if ( keys[SDLK_END]||keys[SDLK_KP1]||keys[SDLK_d] ) {
                camera.Rotate(vec3d(0,0,1),game_dt*spinspeed);
        };
        if ( keys[SDLK_PAGEDOWN]||keys[SDLK_KP3]||keys[SDLK_f]  ) {
                camera.Rotate(vec3d(0,0,1),-game_dt*spinspeed);
        };
        if ( keys[SDLK_KP_PLUS]||keys[SDLK_a] ) {
                cameravel=cameravel+(QuaternionToMatrix(camera.orientation)*vec3d(0,0,-acceleration*game_dt));
        };
        if ( keys[SDLK_KP_MINUS]||keys[SDLK_s]  ) {
                cameravel=cameravel+(QuaternionToMatrix(camera.orientation)*vec3d(0,0,acceleration*game_dt));
        };
        if ( keys[SDLK_SPACE] ) {
                //cameravel=vec3d(0,0,0);
                decrementlen(cameravel,deceleration*game_dt);
        };
        if ( keys[SDLK_c] ) {
                //cameravel=vec3d(0,0,0);
                std::cout<<camera.position;
                std::cout<<camera.orientation;
        };
        if ( keys[SDLK_RETURN] ) {
                //cameravel=vec3d(0,0,0);
                vec3f tmp(camera.position.x*0.1,camera.position.y*0.1,camera.position.z*0.1);
                MovePoint(tmp);
                camera.position.x=tmp.x*10;
                camera.position.y=tmp.y*10;
                camera.position.z=tmp.z*10;
        };


        camera.position=camera.position+cameravel*game_dt;

        //game_dt=0;
        UpdatePoints();

};

void MessageLoop(){
        SDL_Event event;
        while(true){
                while(SDL_PollEvent(&event)){
                        switch(event.type){
                        case SDL_VIDEORESIZE:
                                {
                                        UnInitGL();
                                        screen=SDL_SetVideoMode(event.resize.w, event.resize.h,
                                                screen_bits, SDL_OPENGL|SDL_RESIZABLE);
                                        if(!screen){
                                                std::cout<<"Can't set video mode after resizing ! Exiting."<<std::endl;
                                                SDL_Quit();
                                                exit(2);
                                        };
                                        InitGL();
                                        Reshape(screen->w,screen->h);
                                        break;
                                };
                        case SDL_QUIT:
                                {
                                        return;
                                        break;
                                };
                        };//case
                        keys = SDL_GetKeyState(NULL);
                                if ( keys[SDLK_ESCAPE] ) {
                                        return;
                                }
                };
                Display();
                UpdateWorld();
                SDL_GL_SwapBuffers();
                UpdateTime();
        };//while true;
};

void InitGL(int argc, char *argv[]){
        char *ext = (char*)glGetString( GL_EXTENSIONS );

        if( strstr( ext, "GL_ARB_point_parameters" ) == NULL )
    {
        std::cout<<"No GL_ARB_point_parameters extension ! Exiting."<<std::endl;
                SDL_Quit();
                exit(2);
     }
        glPointParameterfARB  = (PFNGLPOINTPARAMETERFARBPROC)SDL_GL_GetProcAddress("glPointParameterfARB");
        glPointParameterfvARB = (PFNGLPOINTPARAMETERFVARBPROC)SDL_GL_GetProcAddress("glPointParameterfvARB");
        if((!glPointParameterfARB)||(!glPointParameterfARB)){
                std::cout<<"Can not get adresses of extensions!"<<std::endl;
                SDL_Quit();
                exit(2);
        }

        pointtextureID=loadTexture("particle.bmp");
        if(pointtextureID==0){std::cout<<"can not load image."<<std::endl;}

        glDisable(GL_LIGHTING);
        glColor4f(1,1,1,1);
};

void InitSDLGL(int argc, char *argv[]){
        SDL_Init(SDL_INIT_VIDEO);
        win_width=800;
        win_height=500;
   screen = SDL_SetVideoMode(win_width, win_height, screen_bits, SDL_OPENGL|SDL_RESIZABLE);
  if ( ! screen ) {
        std::cout<<"Can't set video mode! Exiting."<<std::endl;
    SDL_Quit();
    exit(2);
  };
   SDL_WM_SetCaption("SDL window", "sdl window");
   InitGL(argc,argv);
   Reshape(screen->w, screen->h);

   InitPoints();

};
void UnInitGL(){
        GLuint texid;
        texid=pointtextureID;
        glDeleteTextures(1,&texid);
        pointtextureID=texid;
};

int main(int argc, char *argv[]){
        //timer calibration period starts
        StartCalibrating();
        InitSDLGL(argc,argv);
        //calibrate the timer
        Calibrate();
        MessageLoop();
        UnInitGL();
        SDL_Quit();
        return 0;
};